/*
 *  Dropbox Javascript library v1.0                                           *
 *  Copyright Peter Josling 2010                                              *
 *	                                                                          *
 *  Requires jQuery 1.4.1 or newer (included in source)                       *
 *	                                                                          *
 *  Uses the Javascript OAuth library by John Kristian                        *
 *  http://oauth.googlecode.com/svn/code/javascript/                          *
 *	                                                                          *
 *  Also uses SHA1.js by Paul Johnston	                                      *
 *  http://pajhome.org.uk/crypt/md5/	                                      *
 *	                                                                          *
 *	                                                                          *
 *  Licensed under the Apache License, Version 2.0 (the "License");           *
 *  you may not use this file except in compliance with the License.          *
 *  You may obtain a copy of the License at                                   *
 *	                                                                          *
 *     http://www.apache.org/licenses/LICENSE-2.0                             *
 *	                                                                          *
 *  Unless required by applicable law or agreed to in writing, software       *
 *  distributed under the License is distributed on an "AS IS" BASIS,         *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  *
 *  See the License for the specific language governing permissions and       *
 *  limitations under the License.                                            */


/*  
 *  ADAPTACI del fitxer Javascript inicial preparat per la versi 0 de DROPBOX      *
 *  a la versi 1 de la interficie de programaci s'amplia per poder emmagatzemar    *
 *  les dades amb el modul de localStorage de PHONEGAP, igualment per al tractament  *
 *  de fitxers s'utilitza el modul File de PHONEGAP                                  *
 *                                                                                   *
 *  Inclusi del pluguin de childbrowser per visualitzar al navegador els fitxers    * 
 *  baixats.                                                                         */

var dropbox = {};
	
// Canvieu les seves prpies claus de l'API de Dropbox
//  whqaios20ir35lp 
dropbox.consumerKey = "crjuwcw0czxgpuq"; 
//  ste9e7z5vamr3ha  
dropbox.consumerSecret = "z3rbo19reldeo2l"; 


// Prefix per dades storate - HA ser nic
dropbox.prefix = "mprogcourse";

// Ajust a "Dropbox" si la seva sol  licitud ha estat donada carpeta Dropbox sandbox de llibertat absoluta
dropbox.accessType = "sandbox";

// Canvieu la lnia segent a true per utilitzar l'emmagatzematge local de HTML5 en lloc de galetes
dropbox.authHTML5 = false;

//S'estableix en false per a deshabilitar l'emmagatzematge en memria cau d'arxius de metadades
dropbox.cache = false;

// Adrea de retorn a la autoritzaci, es possa el fitxer Principal desprs dels pasos d'autoritzaci
dropbox.authCallback = "file:///android_asset/www/avui.html";

// Capacitat mxima d'arxius a la llista d'un directori. 10k per defecte
dropbox.fileLimit = 10000;

// Galetes expirar el temps (en dies). Predeterminat 10 anys
dropbox.cookieTime = 3650;



//S'inclueixen les llibreries de javascript necessaries 
document.write("<script type='text/javascript' src='js/dropbox/oauth.js'></script>");
document.write("<script type='text/javascript' src='js/dropbox/sha1.js'></script>");
// document.write("<script type='text/javascript' src='js/jquery.js'></script>");
 // document.write("<script type='text/javascript' src='js/jquery-1.7.1.min.js'></script>"); 
 // document.write("<script type='text/javascript' src='js/purl.js'></script>");
 




// Si s'utilitza l'emmagatzematge local de HTML5
if (dropbox.authHTML5 == true) {
	console.log("entro en authHTML5");
	// Aconseguir fitxes (noms declara variables si el testimoni existeix)
	temp = localStorage.getItem(dropbox.prefix + "requestToken")
	
	if (temp) {
		dropbox.requestToken = temp;
	}
	
	temp = localStorage.getItem(dropbox.prefix + "requestTokenSecret")
	if (temp) {
		dropbox.requestTokenSecret = temp;
	}
	console.log(temp);
	temp = localStorage.getItem(dropbox.prefix + "accessToken")
	if (temp) {
		dropbox.accessToken = temp;
	}

	temp = localStorage.getItem(dropbox.prefix + "accessTokenSecret")
	if (temp) {
		dropbox.accessTokenSecret = temp;
	}

} else {
	// Com galetes (per als tokens de OAuth emmagatzemats)
	cookies = document.cookie;
	console.log("---------GUARDADO DE COOKIES------------------");
	console.log(cookies);
	cookies = cookies.split(";");


	// Recrrer les galetes per extreure tokens
	for (i in cookies) {
		c = cookies[i];
		while (c.charAt(0) == ' ') c = c.substring(1);
		c = c.split("=");
		switch (c[0]) {
			case dropbox.prefix + "requestToken":				
				dropbox.requestToken = c[1];
			break;
			
			case dropbox.prefix + "requestTokenSecret":
				dropbox.requestTokenSecret = c[1];
			break;
			
			case dropbox.prefix + "accessToken":
				dropbox.accessToken = c[1];
			break;
			
			case dropbox.prefix + "accessTokenSecret":
				dropbox.accessTokenSecret = c[1];
			break;
		}
	}
	
	// fixar la data de caducitat galeta (per a s posterior)
	dropbox.cookieExpire = new Date();
	dropbox.cookieExpire.setDate(dropbox.cookieExpire.getDate()+dropbox.cookieTime);
	dropbox.cookieExpire = dropbox.cookieExpire.toUTCString();
}

// Funci de configuraci s'executa desprs de biblioteques es carreguen
dropbox.setup = function() {
	// Entrem per primer cop des de login borrem el localstorage
	if (document.location =="file:///android_asset/www/login.html"){
		
		 localStorage.removeItem("token_request_autoritzacio");
		 localStorage.removeItem("token_request_autoritzacio_secret");
		 localStorage.removeItem("token_acces_autoritzacio");
		  localStorage.removeItem("token_acces_autoritzacio_secret");
	}
	console.log("entrem dropbox.setup");
	
	// verifica Si ja sha accedit
	console.log("token_acces_autoritzacio antes primer if");
	console.log(localStorage.getItem("token_acces_autoritzacio"));
	console.log("dropbox.accessToken antes primer if");
	console.log(dropbox.accessToken);
	
	if (!dropbox.accessToken && localStorage.getItem("token_acces_autoritzacio") == null) {
		console.log("---------PRIMER IF------------------");
		// Verifica si ja est autoritzat, pero encara no ha donat acces
		console.log(localStorage.getItem("token_request_autoritzacio"));
		
		if (!dropbox.requestToken && localStorage.getItem("token_request_autoritzacio") == null) {   // localStorage.getItem("token_request_autoritzacio_secret")
			console.log("---------PAS1: SEGUNDO IF REQUEST TOKEN------------------");
			// testimoni de request 
			// PAS 1 ......................... PAS1: ES RECULL EL REQUEST TOKEN .....................................
			dropbox.oauthReqeust({
				url: "https://api.dropbox.com/1/oauth/request_token",
				type: "text",
				token: true,
				tokenSecret: true
			}, [], function(data) {
				data = data.split("&");
				dataArray = new Array();
				
				//Parsejem els tokens
				for (i in data) {
					dataTemp =  data[i].split("=");
					dataArray[dataTemp[0]] = dataTemp[1];
				}
				
				// Es guarda el token
				dropbox.storeData("requestToken",dataArray['oauth_token']);		
				dropbox.storeData("requestTokenSecret",dataArray['oauth_token_secret']);
						
				// guardem els tokens al localstorage ....................................................................				
				console.log("tokens guardats");
				console.log(dataArray['oauth_token']);
				localStorage.setItem("token_request_autoritzacio",dataArray['oauth_token']);
				localStorage.setItem("token_request_autoritzacio_secret",dataArray['oauth_token_secret']);
				console.log("---------PAS2: AUTORITZACIO------------------");
				//PAS 2 ......................................PAS2:   AUTORITZACI .................................................
				document.location = "https://www.dropbox.com/1/oauth/authorize?oauth_token=" + dataArray["oauth_token"] + "&oauth_callback=" + dropbox.authCallback;
				console.log("---------PAS2_1: AUTORITZAT AMB ELS TOKEN AUTORITZACI ES GUARDEN?------------------");
			});
		} else {
			console.log("---------PAS3: ELSE ACCES TOKEN----------------------");
			// alert(localStorage.getItem("token_request_autoritzacio"));
			// alert(localStorage.getItem("token_request_autoritzacio_secret"));
			//PAS 3 .................................................PAS 3  ACCES TOKEN PER LES FUNCIONALITATS GET PUT ETC ..............................
			dropbox.oauthReqeust({
				url: "https://api.dropbox.com/1/oauth/access_token",
				type: "text",
				token: localStorage.getItem("token_request_autoritzacio"),
				tokenSecret: localStorage.getItem("token_request_autoritzacio_secret")
			}, [], function(data) {
				data = data.split("&");
				dataArray = new Array();
				
				//Parsejem el token
				for (i in data) {
					dataTemp =  data[i].split("=");
					dataArray[dataTemp[0]] = dataTemp[1];
				}				
				// Es guarda el testimoni
				dropbox.storeData("accessToken",dataArray['oauth_token']);
				dropbox.storeData("accessTokenSecret",dataArray['oauth_token_secret']);
				
				// Actualitzaci de les variables amb fitxes
				dropbox.accessToken = dataArray['oauth_token'];								
				dropbox.accessTokenSecret = dataArray['oauth_token_secret'];
				
				// guardem els tokens dACCES al localstorage ....................................................................			
				localStorage.setItem("token_acces_autoritzacio",dataArray['oauth_token']);
				localStorage.setItem("token_acces_autoritzacio_secret",dataArray['oauth_token_secret']);
				
				console.log("token retornat: ");
				console.log(localStorage.getItem("token_acces_autoritzacio"));
				console.log("token secret retornat: ");
				console.log(localStorage.getItem("token_acces_autoritzacio_secret"));
				
			});									
		}
	}
	console.log("sortim de  dropbox.setup");
};


// Executeu el programa quan tot est carregada
window.onload = dropbox.setup;

//Funci per enviar sol.licituds OAuth
dropbox.oauthReqeust = function(param1,param2,callback) {
	// Si el testimoni no estava definit en la crida a la funci, a continuaci, utilitzar el token d'accs

	// alert(dropbox.accessToken);
	// REFERENCIA
	// alert(param1.token);
	// Es guarda els testimonis a dins el localstorage de phonegap
	if (!param1.token) {  // true cuando request   -- false cuando acces
		if (localStorage.getItem("token_acces_autoritzacio") == null){
			param1.token = localStorage.getItem("token_request_autoritzacio");
		} else {
			param1.token = localStorage.getItem("token_acces_autoritzacio");	
		}

	}
	if (!param1.tokenSecret) {   // true cuando request -- false cuando acces
		
		if (localStorage.getItem("token_acces_autoritzacio_secret") == null){
			param1.tokenSecret = localStorage.getItem("token_request_autoritzacio_secret");
		} else {
			param1.tokenSecret= localStorage.getItem("token_acces_autoritzacio_secret");	
		}
	}
	
	// Si el tipus no est definit, s JSON
	if (!param1.type) {
		param1.type = "json";
	}
	
	// Si el mtode no est definit, assumeix que s GET
	if (!param1.method) {
		param1.method = "GET";
	}
	
	//Defineix l'accesor  
	accessor = {
		consumerSecret: dropbox.consumerSecret,
	};
	
	//Tipus de clau per la autoritzaci algoritme HMAC-SHA1 o text pla PLAINTEXT
	message = {
		action: param1.url,
	    method: param1.method,
	    parameters: [
	      	["oauth_consumer_key", dropbox.consumerKey],
	      	["oauth_signature_method","HMAC-SHA1"] 
	  	]
	};
	
	// Noms afegir fitxes a la sol  licitud si se't vol (vars no s'usa per a true)
	if (param1.token != true) {
	//	message.parameters.push(["oauth_token",param1.token]);
		if (localStorage.getItem("token_acces_autoritzacio") == null){
			message.parameters.push(["oauth_token",localStorage.getItem("token_request_autoritzacio")]);
		} else {
			message.parameters.push(["oauth_token",localStorage.getItem("token_acces_autoritzacio")]);	
		}
		
	}
	if (param1.tokenSecret != true) {
	//	accessor.tokenSecret = param1.tokenSecret;
		if (localStorage.getItem("token_acces_autoritzacio_secret") == null){
			accessor.tokenSecret = localStorage.getItem("token_request_autoritzacio_secret");
		} else {
			accessor.tokenSecret = localStorage.getItem("token_acces_autoritzacio_secret");
		}
		
	}
	
	//Si se'ls dna, afegiu els parmetres especfics de sollicitud a la sol  licitud de OAuth 
	for (i in param2) {
		console.log("param2[i]_-------------------------------------------------");
		console.log(param2[i]);
		message.parameters.push(param2[i]);
	}
	
	//Timestamp i senyal  the OAuth request
	OAuth.setTimestampAndNonce(message);
	OAuth.SignatureMethod.sign(message, accessor);
	console.log(message.action);  // get file upload file etc
	console.log(message.parameters); // parmetres per accedir
	//Post la petici OAuth
	$.ajax({
		url: message.action,
		type: message.method,
		data: OAuth.getParameterMap(message.parameters),
		dataType: param1.type,
		success: function(data) {
			//OAuth sollicitud xit - callback run
			callback(data);
			console.log("AUTORITZACI CORRECTA");
		},	
		error: function(a,b,c) {
			// Quelcom ha fallat. Sintase lliure d'afegir un missatge d'error millor si vols
			console.log("error");
			console.log(a);
			console.log(b);
			console.log(c);
			alert("S'ha produit un error a la conexi amb DropBox");
			alert("el fitxer no existeix o la sessio ha caducat. Si us plau torni a autenticarse a l'aplicaci");
		}
	});
}


/*    Funcions publiques definides per interficie de DROPBOX versi 1.0    */

//Funci per obtenir informaci del compte d'usuari
dropbox.getAccount = function(callback) {
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/account/info"
	}, [], function(data) {
		// callback(data);
		console.log(data.display_name);
		console.log(data.referral_link);	
		console.log(data.uid);	
		console.log(data.country);	
		console.log(data.quota_info.normal);	
		console.log(data.quota_info.shared);	
		console.log(data.quota_info.quota);
		
	
	});
}

// Funci javascript per poder visualitzar el fitxer mitjanant childBrowser 
function visualitzaFitxer(){window.plugins.childBrowser.showWebPage("file:///data/data/com.pfc.src/app_files/"+localStorage.getItem("fitxer"), { showLocationBar: true });}
// "file:///data/data/com.pfc.src/app_files/"+localStorage.getItem("fitxer") "https://dl.dropbox.com/s/dt4jwvbzgizjm2q/Comenzar.pdf"


// Funci per obtenir el contingut d'un arxiu
dropbox.getFile = function(path,callback) {
	dropbox.oauthReqeust({
		url: "https://api-content.dropbox.com/1/files/" + dropbox.accessType + "/" + path,
		type: "text"
	}, [], function(data) {
			
		// Recullim el tipus de fitxer
		var mimetype = localStorage.getItem("metaDadesTemp");

		if (mimetype == ("text/plain")){
			
			// si es text ho visualitzem amb el pluggin de childbrowser
			var file = new DirectoryEntry(localStorage.getItem("fitxer"), "/data/data/com.pfc.src/app_files/");
			file.getFile(localStorage.getItem("fitxer"), {create: true, exclusive: false}, function(fileEntry){fileEntry.createWriter(function(writer){writer.write(data);}, fail);}, fail);
			console.log("es guarda el fitxer amb extensi text i ho visualtizem");
			window.setTimeout("visualitzaFitxer()",500);
			 		
		}
		if (mimetype == ("application/pdf")){
			 // ..............visualitzador de fitxers pdf..................................................................
			//	var pdf = new PdfViewer(); window.plugins.pdfViewer.showPdf("/data/data/com.pfc.src/app_files/Comenzar.pdf");
		}
		
	   
	});
}


// Funci que permet recollir les dades descriptives internes d'un fitxer
dropbox.getMetadata = function(path,callback) {
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/metadata/" + dropbox.accessType + "/" + path
	}, [["list","false"]], function(data) {
//		console.log(data.rev); (data.thumb_exists)(data.bytes)(data.modified)(data.client_mtime)(data.path)(data.is_dir)(data.icon)console.log(data.root); 
//		console.log(data.mime_type); console.log(data.revision); console.log(data.size);
		// Es verifica el fitxer i es guarda
		// guardem el fitxer al fileSystem
		localStorage.setItem("metaDadesTemp",data.mime_type);

	});
}




// Funci per emmagatzemar les dades dels fitxers  utilitzant ja sigui galetes o HTML5, segons l'elecci
dropbox.storeData = function(name,data) {
	// Escapar les dades que vulgueu conservar
	data = escape(data);
	
	// mode local storage 
	if (dropbox.authHTML5 == true) {
		localStorage.setItem(dropbox.prefix + name,data);
	} else {
		//Guardar dades a les galetes
		document.cookie = dropbox.prefix + name + "=" + data + "; expires=" + dropbox.cookieExpire + "; path=/";
	}
}

//Funci per obtenir les dades (fitxes / cache) utilitzant ja sigui galetes o HTML5, depenent de l'elecci
dropbox.getData = function(name) {
	//mode local storage
	if (dropbox.authHTML5 == true) {
		return unescape(localStorage.getItem(dropbox.prefix + name));
	} else {
		//Recollir galetes
		cookies = document.cookie;
		cookies = cookies.split(";");
		
		//Recrrer les galetes per trobar la correcta
		for (i in cookies) {
			c = cookies[i];
			while (c.charAt(0) == ' ') c = c.substring(1);
			c = c.split("=");
			if (c[0] == dropbox.prefix + name) {
				return unescape(c[1]);
			}
		}
	}
}





//Funci per obtenir una llista dels continguts d'un directori
dropbox.getFolderContents = function(path,callback) {
	//Si la memria cau est habilitada, obtenir el hash de la carpeta sollicitada
	if (dropbox.cache == true) {
		//Obtenir les dades emmagatzemades a la memria cau
		hash = dropbox.getData("cache." + path);
		
		//Si les dades emmagatzemades a la memria cau existeix
		if (hash != "null") {
			//Analitzar les dades en memria cau i extreure el hash
			hash = jQuery.parseJSON(hash).hash;
		} else {
			//S'estableix en un hash en blanc
			hash = "00000000000000000000000000000000";
		}
	} else {
		//S'estableix en un hash en blanc
		hash = "00000000000000000000000000000000";
	}
	
	//Enviar la sollicitud de OAuth
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/metadata/" + dropbox.accessType + "/" + path,
		type: "text"
	}, [
		["list","true"],
		["status_in_response","true"],
		["hash",hash]
	], function(data) {
		//Si la memria cau est activat, comproveu que el contingut de la carpeta ha canviat
		if (dropbox.cache == true) {
			if (jQuery.parseJSON(data).status == 304) {
				//Els continguts no han canviat - tornar les dades emmagatzemades en memria cau en lloc
				data = dropbox.getData("cache." + path);
			} else {
				//Extreu la matriu objecte JSON
				data = data.substr(1);
				while (data.charAt(0) != "{") data = data.substr(1);
				data = data.substr(0,data.length-1);
				while (data.charAt(data.length-1) != "}") data = data.substr(0,data.length-1);
				
				//Contingut ha canviat - cache per a la posterior
				dropbox.storeData("cache." + path,data);
			}
		}
		
		//Analitzar les dades com JSON
		data = jQuery.parseJSON(data);
		
		//Executar la devoluci de trucada
		callback(data);
	});
}



//Funci per moure un arxiu / carpeta a una nova ubicaci
dropbox.getFileMove = function(from,to,callback) {
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/fileops/move"
	}, [
		["from_path",from],
		["to_path",to],
		["root",dropbox.accessType]
	], function(data) {
		callback(data);
	});
}

//Funci per copiar un arxiu / carpeta a una nova ubicaci
dropbox.copyItem = function(from,to,callback) {
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/fileops/copy"
	}, [
		["from_path",from],
		["to_path",to],
		["root",dropbox.accessType]
	], function(data) {
		callback(data);
	});
}

//Funci per esborrar un arxiu / carpeta
dropbox.deleteItem = function(path,callback) {
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/fileops/delete",
		type: "text"
	}, [
		["path",path],
		["root",dropbox.accessType]
	], function(data) {
		callback(data);
	});
}

//Funci per esborrar un arxiu / carpeta
dropbox.deleteItem = function(path,callback) {
	dropbox.oauthReqeust({
		url: "https://api.dropbox.com/1/fileops/create_folder"
	}, [
		["path",path],
		["root",dropbox.accessType]
	], function(data) {
		callback(data);
	});
}

//Funci per obtenir una imatge en miniatura d'una imatge
dropbox.getThumbnail = function(path,size) {
	//Parmetre "mida" Check s vlid
	if (size != "small" && size != "medium" && size != "large") size = "small";
	
	//Enviar una petici de OAuth
	dropbox.oauthReqeust({
		url: escape("https://api-content.dropbox.com/1/thumbnails/" + dropbox.accessType + "/" + path),
		type: "text"
	}, [["size",size]], function(data) {
		callback(data);
	});
}

//Funci per carregar un arxiu
dropbox.uploadFile = function(path,file) {
	dropbox.oauthReqeust({
		url: escape("https://api-content.dropbox.com/1/files/" + dropbox.accessType + "/" + path),
		type: "text",
		method: "POST"
	}, [["file",file]], function(data) {
		callback(data);
	});
}