package com.pfc.src;

import org.apache.cordova.Storage;

import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.util.Log;
import android.webkit.WebView;

import com.dropbox.client2.DropboxAPI;
import com.dropbox.client2.android.AndroidAuthSession;
import com.dropbox.client2.android.AuthActivity;
import com.dropbox.client2.session.AccessTokenPair;
import com.dropbox.client2.session.AppKeyPair;
import com.dropbox.client2.session.Session.AccessType;
import com.pfc.src.loginpreference.SessionManager;
import com.pfc.src.util.Constants;

public class AutenticacioDropBoxActivity extends AuthActivity {
	

	// tipus dacces
	final static private AccessType ACCESS_TYPE = AccessType.APP_FOLDER;
	// nom del fitxer a shared preference
	private static final String PREF_NAME = "tokens";
	 // Edici de les shared preference
    Editor editor;
	private DropboxAPI<AndroidAuthSession> mDBApi;
	
	 @Override
	    public void onCreate(Bundle savedInstanceState) {
		 
		 // Creaci del parell de claus
		 AppKeyPair appKeys = new AppKeyPair(Constants.getAPP_KEY(), Constants.getAPP_SECRET());
		 // Creaci de la sesi amb les claus amb el tipus dacces (app_folder) solament a nivell de carpeta
		 AndroidAuthSession session = new AndroidAuthSession(appKeys, ACCESS_TYPE);
		 // recull la sessi de DropBox si ha anat be
		 mDBApi = new DropboxAPI<AndroidAuthSession>(session);		 
		// autenticaci amb Dropbox
		 mDBApi.getSession().startAuthentication(AutenticacioDropBoxActivity.this);	
		 super.onCreate(savedInstanceState);
	 }
	 
	 protected void onResume() {
		    super.onResume();

		    if (mDBApi.getSession().authenticationSuccessful()) {
		        try {
		            // Trucada obligatoria per completar la autoritzaci
		            // Estableix el token d'accs de la sessi
		            mDBApi.getSession().finishAuthentication();
		            AccessTokenPair tokens = mDBApi.getSession().getAccessTokenPair();
		            // Proporcionar als seus propis storeKeys per conservar el parell testimoni d'accs
		            // podriem guardar els tokens al shared preferences
	           
		           SessionManager sm = new SessionManager(getApplicationContext());
		           SharedPreferences valors = getSharedPreferences(PREF_NAME, 0);
		           editor = valors.edit();
		           editor.putString(Constants.getAPP_TOKEN(), tokens.key);
		           editor.putString(Constants.getAPP_TOKEN_SECRET(), tokens.secret);
		           // Fem la validaci
		           editor.commit();
		           

		           
		        } catch (IllegalStateException e) {
		            Log.i("DbAuthLog", "Error a la autenticaci", e);
		        }
		    }
		}

}
