package com.pfc.src;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.pfc.src.interficie.MyAndroidToJsInterface;

public class ComunicacioNativaJsActivity extends Activity implements MyAndroidToJsInterface, OnClickListener {
	
	   private WebView  browser;  
	    private EditText txt1;  
	      
	    @Override  
	    public void onCreate(Bundle savedInstanceState) {  
	        super.onCreate(savedInstanceState);  
	        this.setContentView(R.layout.main);   
	        browser = (WebView) findViewById(R.id.webview);  
	        Button btn1 = (Button) findViewById(R.id.btn1);  
	        txt1 = (EditText) findViewById(R.id.txt1);  
	          
	        browser.getSettings().setJavaScriptEnabled(true);  
	        browser.addJavascriptInterface(this, "jsNativeInterface");  
	        browser.loadUrl("file:///android_asset/carlos-garcia.html");  
	        btn1.setOnClickListener(this);  
	    }  
	      
	    @Override  
	    public boolean onKeyDown(int keyCode, KeyEvent event) {  
	        if ((keyCode == KeyEvent.KEYCODE_BACK) && browser.canGoBack()) {  
	            browser.goBack();  
	            return true;  
	        }  
	        return super.onKeyDown(keyCode, event);  
	    }     
	      
	    /** 
	     * Llamamos desde Android a Javascript 
	     * android.view.View.OnClickListener 
	     */  
	    public void onClick(View v) {  
	        browser.loadUrl("javascript:callFromAndroidToJS('" + txt1.getText().toString() + "')");  
	          
	    }     
	      
	    /** 
	     * Este mtodo es invocado desde JavaScript => Muestra un mensaje por pantalla 
	     * MyAndroidToJsInterface 
	     */  
	    public void metodoDemo1() {  
	        Toast.makeText(this, "Invocado el metodo: metodoDemo1", Toast.LENGTH_SHORT).show();  
	    }  
	      
	    /** 
	     * Este mtodo es invocado desde JavaScript => Devuelve un objeto JSON desde la aplicacin Nativa  
	     * MyAndroidToJsInterface 
	     */  
	    public String metodoDemo2() {  
	        String toReturn = null;  
	          
	        try {  
	            JSONObject json = new JSONObject();  
	            json.put("timestamp", System.currentTimeMillis());  
	            json.put("autor",     "http://www.carlos-garcia.es");  
	            toReturn = json.toString();  
	        } catch (JSONException e) {  
	            // no se dar  
	        }  
	  
	        return toReturn;  
	    } 

}
