package com.pfc.src;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Toast;

import com.pfc.src.loginpreference.AlertDialogManager;
import com.pfc.src.loginpreference.SessionManager;
 
public class LoginActivity extends Activity {
 
    // Email, password edittext
    EditText txtUsername, txtPassword;
 
    // botons
    Button btnLogin;
    // ImgaButons
    ImageButton btnTwitter;
 
    // Alert Dialog Manager
    AlertDialogManager alert = new AlertDialogManager();
 
    // Session Manager Class
    SessionManager session;
 
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login); 
 
        // Session Manager
        session = new SessionManager(getApplicationContext());                
 
        // Email, Password input text
        txtUsername = (EditText) findViewById(R.id.txtUsername);
        txtPassword = (EditText) findViewById(R.id.txtPassword); 
 
        Toast.makeText(getApplicationContext(), "User Login Status: " + session.isLoggedIn(), Toast.LENGTH_LONG).show();
 
        // bot de login
        btnLogin = (Button) findViewById(R.id.btnLogin);
        // Event del bot de login
        btnLogin.setOnClickListener(new View.OnClickListener() {
           @Override
            public void onClick(View arg0) {
            	// Donar nom dusuari i passowrd amb EditText
                String username = txtUsername.getText().toString();
                String password = txtPassword.getText().toString();
 
                // Verifica si els camps estan omplerts
                if(username.trim().length() > 0 && password.trim().length() > 0){
                	// El testeig es far amb dades simples 
                    // username = test
                    // password = test
                    if(username.equals("test") && password.equals("test")){
 
                    	// Es crea la sessi amb el logeig
                        // Per a la prova que estic stroing nom, adrea de correu electrnic
                        // Utilitzar les dades reals dels usuaris
                        session.createLoginSession("Curs intern recursiu amb materials", "mProgCourse@gmail.com");
 
                        // Obrim MainActivity
                        Intent i = new Intent(getApplicationContext(), MainActivity.class);
                        startActivity(i);
                        finish();
 
                    }else{
                        // username / password no es troba
                        alert.showAlertDialog(LoginActivity.this, "Login failed..", "Username/Password is incorrect", false);
                    }
                }else{
                    // user didn't entered username or password usuario no a entrat el usernam o el password
                    // Mostrar lalert
                    alert.showAlertDialog(LoginActivity.this, "Login failed..", "Please enter username and password", false);
                }
 
            }
        });
        
        // bot per redireccionar a twitter
        btnTwitter = (ImageButton) findViewById(R.id.botonTwitter);
        
        btnTwitter.setOnClickListener(new   View.OnClickListener() {     
            @Override
            public void onClick(View arg0) {
            	// Anem al logeig de twitter
                Intent i = new Intent(getApplicationContext(), LoginActivityTwitter.class);
                startActivity(i);
                finish();
            }
        });
        
        
    }
}
