package com.pfc.src;

import java.util.HashMap;

import org.apache.cordova.DroidGap;

import android.content.Intent;
import android.os.Bundle;
import android.text.Html;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.pfc.src.loginpreference.AlertDialogManager;
import com.pfc.src.loginpreference.SessionManager;
 
public class MainActivity extends DroidGap {
 
    // Alert Dialog Manager
    AlertDialogManager alert = new AlertDialogManager();
 
    // Session Manager Class
    SessionManager session;

    // Bot Logout
    Button btnLogout;
    // Bot aplicaci
    Button btnAplicacio;
    
    Button btnMantenimentBBDD;
    Button btnAuthDropBox; 
 
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
 
        // Instancia de la classe de sessi
        session = new SessionManager(getApplicationContext());
 
        TextView lblName = (TextView) findViewById(R.id.lblName);
        TextView lblEmail = (TextView) findViewById(R.id.lblEmail);
 
        // Bot logout
        btnLogout = (Button) findViewById(R.id.btnLogout);
        // Bot aplicaci
        btnAplicacio = (Button) findViewById(R.id.btnAplicacio);
        // Bot mantenimient Usuari
        btnMantenimentBBDD = (Button) findViewById(R.id.btnMantenimentBBDD);
        // Bot authenticaci DropBox
        btnAuthDropBox = (Button) findViewById(R.id.btnAuthDropBox);
        
 
        Toast.makeText(getApplicationContext(), "User Login Status: " + session.isLoggedIn(), Toast.LENGTH_LONG).show();
 
        /**
         * Call this function whenever you want to check user login
         * This will redirect user to LoginActivity is he is not
         * logged in
         * */
        session.checkLogin();
 
        // get user data from session
        HashMap<String, String> user = session.getUserDetails();
 
        // name
        String name = user.get(SessionManager.KEY_NAME);
 
        // email
        String email = user.get(SessionManager.KEY_EMAIL);
 
        // mostrant les de dades dusuari
        lblName.setText(Html.fromHtml("Name: <b>" + name + "</b>"));
        lblEmail.setText(Html.fromHtml("Email: <b>" + email + "</b>"));
 
        /**
         * event de onclick del bot Logout
         * */
        btnLogout.setOnClickListener(new View.OnClickListener() {     
            @Override
            public void onClick(View arg0) {
                // Clear the session data
                // This will clear all session data and
                // redirect user to LoginActivity
                session.logoutUser();
            }
        });      
        /**
         * event de onclick del bot per anar a aplicaci
         * */
        btnAplicacio.setOnClickListener(new   View.OnClickListener() {
        
            @Override
            public void onClick(View arg0) {
            	// Obrim la activitat principal
                Intent i = new Intent(getApplicationContext(), MyPhoneGapActivity.class);
                startActivity(i);
                // TODO 
                //  finish();            
            }
        });
        /**
         * event de onclick del bot de manteniment de la BBDD        
         **/
        btnMantenimentBBDD.setOnClickListener(new   View.OnClickListener() {
        
            @Override
            public void onClick(View arg0) {
            	// Obrim la activitat principal
                Intent i = new Intent(getApplicationContext(), MantUsuariActivity.class);
                startActivity(i);
                // TODO 
                //  finish();
            }
        });
        
     
        /**
         * event de onclick del bot de autenticaci DropBox       
         **/
        btnAuthDropBox.setOnClickListener(new   View.OnClickListener() {
        
            @Override
            public void onClick(View arg0) {
            	// Obrim la activitat principal
                Intent i = new Intent(getApplicationContext(), AutenticacioDropBoxActivity.class);
                startActivity(i);
                // TODO 
                
            }

        });
        
    }
 
}
