package com.pfc.src;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.cordova.DroidGap;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.Settings.System;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.pfc.src.bbdd.MProgCourseBBDD;
import com.pfc.src.bbdd.TaulaUsuaris;

public class MantUsuariActivity extends DroidGap {
	
	// MProgCourseBBDD
	
	private MProgCourseBBDD miBD;
	private MProgCourseBBDD miBD2;
	
	// Taula de usuaris
	private TaulaUsuaris taulaUsuaris;
	
	// cursor d'us general
	private Cursor cur;
	
	   Button btnAplicacio;
 
	// cursor auxiliar per  actualitzar/eliminar
	private Cursor cur2;
	 
	private boolean bCurActivo = false;
	
	// dades de la fila vigent
	private Integer intIdUsuariVigent;
	private String strNomUsuariVigent;
	private String strRolVigent;
	private String strDescUsuariVigent;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mant_usuari);    
       
        try {        	
        	String carpetaDest =  "/data/data/" + getPackageName() + "/app_files/";
        	File fi = getBaseContext().getDatabasePath("/data/data/" + getPackageName() + "Mprogcourse_bbdd");
        	File f = new File(carpetaDest);        	
        	if (!f.exists()) {        	
        		copiarBD( getBaseContext().getAssets().open("M_PROG_COURSE.db"), new FileOutputStream(carpetaDest));
        	}
        } catch (FileNotFoundException e) {			
        	e.printStackTrace();
        } catch (IOException e) {
        	e.printStackTrace();
        }
       
        // crea lobjecte de taula de usuaris que hereda base de dades
       miBD = new MProgCourseBBDD(this); 
       miBD2 = new MProgCourseBBDD(this); 
       
       btnAplicacio = (Button) findViewById(R.id.botoTornarMantUsuari);
       
       /**
        * event de onclick del bot per anar a menu principal
        * */
       btnAplicacio.setOnClickListener(new   View.OnClickListener() {
       
           @Override
           public void onClick(View arg0) {
           	// Obrim la activitat principal
               Intent i = new Intent(getApplicationContext(), MainActivity.class);
               startActivity(i);
               // TODO 
               //  finish();            
           }
       });
       

    }
    

    
	 public void onClickInsertar(View v) {
     	
		 String msg;
		 // Agafa els valors de les caixes de text del layout de mant_usuari.xml
	      if (readInterficie()!=1){
          	msg ="No hi ha dades, com a minim sha de possar un nom";
          	Toast.makeText(this,  msg, Toast.LENGTH_LONG).show();
          	return;
          }		 
		 // afegim registre
     
         miBD.open(); 
         long id = miBD.insertaFilaUsuari(strNomUsuariVigent, strRolVigent, strDescUsuariVigent);
                          
         if (id != -1) { 
         	msg = "Fila insertada amb clau " + String.valueOf(id);
         	netejaInterficie();} 
         else msg ="No sha insertat cap fila";
         Toast.makeText(this,  msg, Toast.LENGTH_LONG).show();
           
         miBD.close();
         // los botones de edicin se desactivan
         botonesEdicion(false);
	}
	 
		public void onClickEliminar(View v) {   
        	// eliminar una fila por nmero de identificador
        	miBD.open();
        	if (miBD.eliminarFila(intIdUsuariVigent)){
        		Toast.makeText(this, "eliminat", Toast.LENGTH_LONG).show();
        		netejaInterficie();
        	}
        	else  Toast.makeText(this, "no sha pogut eliminar", Toast.LENGTH_LONG).show();            
        	miBD.close();
	}
	 
	
	 
		public int readInterficie(){
			// obte les dades del quadre de text
	        EditText objEt1 = (EditText) findViewById(R.id.EditText_Nom_Usuari);
	        strNomUsuariVigent =  objEt1.getText().toString();
	        
	        EditText objEt2 = (EditText) findViewById(R.id.EditText_Rol);
	        strRolVigent =  objEt2.getText().toString();
	        
	        EditText objEt3 = (EditText) findViewById(R.id.EditText_Desc_Usuari);
	        strDescUsuariVigent =  objEt3.getText().toString();
	        
	        int retornaValor= 0;
	        
	        if (strNomUsuariVigent != null && !"".equals(strNomUsuariVigent)){
	        	retornaValor = 1;
	        }
	        
	        // evitamos que haya puntos igual a 0
	        // en la tabla
	        return retornaValor;		
		}
	 
		public void netejaInterficie(){
			// limpia los datos de la interfaz		
	        EditText objEt1 = (EditText) findViewById(R.id.EditText_Nom_Usuari);
	        objEt1.setText("");
	        
	        EditText objEt2 = (EditText) findViewById(R.id.EditText_Rol);
	        objEt2.setText("");
	        
	        EditText objEt3 = (EditText) findViewById(R.id.EditText_Desc_Usuari);
	        objEt3.setText("");
	        
	        botonesEdicion(false);		
		}
		
		public void botonesEdicion(boolean b){
			// activa o desactiva els botons de actualitzar o eliminar
			// segons es trovi o no una fila mostrada
			// a la zona de edicin
			 Button objB1 = (Button) findViewById(R.id.button4);
		     objB1.setClickable(b);
		     
		     Button objB2 = (Button) findViewById(R.id.button5);
		     objB2.setClickable(b);
		}
	 

    
//	public void onClickListarParaEditar(View v) {
//		
//    	// obtiene un cursor 
//		// para editar fila a fila
//	    if (!bCurActivo) {
//	    	miBD2.open();
//
//	    	// obt la llista complerta de files
//	    	
//	    	cur2 = miBD2.leerTodos();
//	    	bCurActivo = true;
//	    	// posiciona en la primera fila 
//	      	if (cur2.moveToFirst())  {
//	      		// coloca los datos en los cuadros de edicin
//            	putInterfaz(cur2);
//            }
//	    	else {
//	    		// la tabla no tiene ninguna fila
//	    		Toast.makeText(this, "No hay ninguna fila", Toast.LENGTH_LONG).show(); 
//	    		cur2.close();
//	    		miBD2.close();
//	    		bCurActivo = false;
//	    	} 
//	    } else {
//	    	// nos movemos por el cursor
//	    	if (cur2.moveToNext()) { 
//	    		// coloca los datos en los cuadros de edicin
//				putInterfaz(cur2);
//			} else {
//				// fin de filas
//				cur2.close();
//				miBD2.close();
//				bCurActivo = false;
//				Toast.makeText(this, "Ya no hay ms filas", Toast.LENGTH_LONG).show();
//				botonesEdicion(false);
//			}	
//	    }
	  
//}
    
    /**
     * Fa una copia de la base de dades de laplicaci
     * @param inputStream
     * @param outputStream
     * @throws IOException
     */
    public void copiarBD(InputStream inputStream, OutputStream outputStream) 
		    throws IOException {
		// copia de a 1024 bytes
		byte[] buffer = new byte[1024];
		int length;
		while ((length = inputStream.read(buffer)) > 0) {
			outputStream.write(buffer, 0, length);
		}
		inputStream.close();
		outputStream.close();
		}
	

}
