package com.pfc.src.bbdd;

import android.content.Context;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import com.pfc.src.util.Constants;

public class MProgCourseBBDD {
	
	 // Nom de la Base de dades
	 private static final String NOMBRE_BD = "M_PROG_COURSE.db";	
	 private static final int VERSIO_BBDD = 2;
	 
	 
	 private static final String ID_LOG = "Gestor de base de datos";

	        
	 private final Context contexto; 
	 
	 // base de dades de la aplicaci
	 private SQLiteDatabase bbdd;
	 
	 // objeto base de datos auxiliar
	 private AuxiliarBD AuxBD;
	 
	 // Taula Usuari
	 private TaulaUsuaris taulaUsuaris;
	 

	 public MProgCourseBBDD(Context ctx) {
	        this.contexto = ctx;
	        AuxBD = new AuxiliarBD(contexto);
	 }
	 
	 // clase auxiliar para crear y mantener la
	 // versin de la base de datos
	 private static class AuxiliarBD extends SQLiteOpenHelper  {
		 
		 AuxiliarBD(Context context) 
		 {
	            super(context, NOMBRE_BD, null, VERSIO_BBDD);
		 }

		 @Override
		 public void onCreate(SQLiteDatabase bd)  {
			 
			 // Creaci de les taules de la Base de dades M_PROG_COURSE
			 try {
				 bd.execSQL(Constants.CREATE_TAULA_USUARI);
//				 bd.execSQL(Constants.CREATE_CALENDARI_CURS);
//				 bd.execSQL(Constants.CREATE_CONSULTOR);
//				 bd.execSQL(Constants.CREATE_MATERIA);
//				 bd.execSQL(Constants.CREATE_RECURS_TEMATICA);
//				 bd.execSQL(Constants.CREATE_ROL);
//				 bd.execSQL(Constants.CREATE_TEMATICA);
				 
				 
				 } 
			 catch (SQLException e) {e.printStackTrace();}
		 }
	  
		 @Override
		 public void onUpgrade(SQLiteDatabase bd, int oldVersion, int newVersion)  {
			  // actualitza la versi de la bbdd
			  Log.w(ID_LOG, "Actualitza la versi: " + 
					  oldVersion + 
					  " per la nova versi: " + 
					  newVersion + 
					  " (aix eliminar les dades!!)");
			  
			  // Si existeisen les taules les elimina
			  
//			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_CALENDARI_CURS);
//			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_CONSULTOR);
//			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_MATERIA);
//			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_RECURS_TEMATICA);
//			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_ROL);
//			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_TEMATICA);
			  bd.execSQL("DROP TABLE IF EXISTS " + Constants.CREATE_TAULA_USUARI);
			  
			  // recrea la bbdd
		      onCreate(bd);
		  	}
	 	}    

	 /**
	  * Crea o obre la Base de dades
	  * @return
	  * @throws SQLException
	  */
	 public MProgCourseBBDD open() throws SQLException   {
	 		bbdd = AuxBD.getWritableDatabase();
	 		return this;
	 }

	 /**
	  * Tanca la bbdd  
	  */
	 public void close()  {
	        AuxBD.close();
	 }
	 
	 /**
	  * 
	  */
	 public long insertaFilaUsuari(String nom_usuari, String rol, String desc_usuari){	
		 taulaUsuaris = new TaulaUsuaris();
		 return  taulaUsuaris.insertarFila(nom_usuari, rol, desc_usuari, bbdd);	 	 
	 }
	 
	 public boolean eliminarFila(Integer valor_id_usuari){
		 return taulaUsuaris.eliminarFila(valor_id_usuari, bbdd);
	 }
	    




}
