package com.pfc.src.bbdd;

import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

import com.pfc.src.util.Constants;

public class TaulaUsuaris {
	

	 
	 // Noms de les dades de la taula Usuari
	 public static final String ID_USUARI = "id_usuari";
	 public static final String NOM_USUARI = "nom_usuari";
	 public static final String ROL = "rol"; 
	 public static final String DESC_USUARI  = "desc_usuari"; 
	// public static final String DATA_USUARI = "data_usuari"; 
	 
	 
	 /**
	  * Inserta una fila a la taula de usuaris, retorna un long amb un valor -1 quan no sinserta
	  * @param nom_usuari
	  * @param rol_id
	  * @param rol_nom
	  * @param desc_usuari
	  * @param data_usuari
	  * @param bbdd
	  * @return
	  */
	 public long insertarFila(String nom_usuari, String rol, String desc_usuari, SQLiteDatabase bbdd)   {
	 		// inserci duna fila a la taula

		 
	 		ContentValues valores = new ContentValues();
	 	// Noms de les dades de la taula Usuari
	 		 valores.put(NOM_USUARI, nom_usuari);
	 		 valores.put(ROL, rol); 
	 		 valores.put(DESC_USUARI, desc_usuari); 
	 		return bbdd.insert(Constants.TAULA_USUARI, null, valores);
	 }
	 
	/**	
	 *  Actualitzaci de taula
	 * @param valor_id_usuari
	 * @param nom_usuari
	 * @param rol_id
	 * @param rol_nom
	 * @param desc_usuari
	 * @param data_usuari
	 * @param bbdd
	 * @return
	 */
	public int actualizarFila(Integer valor_id_usuari, String nom_usuari, String rol, String desc_usuari, String  data_usuari, SQLiteDatabase bbdd) {
		 		 
		 	// formato update
		 	// 	update(String table, ContentValues values, String whereClause, String[] whereArgs)			
	 		ContentValues valores = new ContentValues();
		 	// Noms de les dades de la taula Usuari
		 		 valores.put(NOM_USUARI, nom_usuari);
		 		 valores.put(ROL, rol); 
		 		 valores.put(DESC_USUARI, desc_usuari); 
		 		 
		 		return bbdd.update(Constants.TAULA_USUARI, valores,	"id_usuari" + "=" + valor_id_usuari, null);
		 	}

	 /**
	  * Elimina un registre de la taula dUsuaris
	  * @param id
	  * @param bbdd
	  * @return
	  */
	 public boolean eliminarFila(Integer valor_id_usuari, SQLiteDatabase bbdd)  {

	 		// format delete
	 		// 	delete(String table, String whereClause, String[] whereArgs)				
	 		// devuelve cantidad de filas eliminadas
	 		return bbdd.delete(Constants.TAULA_USUARI, ID_USUARI + "=" + valor_id_usuari, null) > 0;
	 }
	 
	 /**
	  * Elimina tota la taula
	  * @param bbdd
	  * @return
	  */
	 public boolean eliminarTodo(SQLiteDatabase bbdd)  {

	 		// format delete
	 		// 	delete(String table, String whereClause, String[] whereArgs)			

	 		return bbdd.delete(Constants.TAULA_USUARI, null, null) > 0;
	 }
	 

	 	//  recupera un conjunt de files ordenat de manera descendent pel nom dusuari retorna un objecte cursor

	public Cursor llegirTots(SQLiteDatabase bbdd)  {
	        return bbdd.query(true,
		        		Constants.TAULA_USUARI, 
		        		new String[] {Constants.TID_USUARI, Constants.TNOM_USUARI, Constants.TROL, Constants.TDESC_USUARI}, 
		        		null, null, null, null, 
		        		Constants.TNOM_USUARI + " DESC",
		        		"100");
	}

}
