package com.pfc.src.sessioDropBox;

import com.dropbox.client2.DropboxAPI;
import com.dropbox.client2.android.AndroidAuthSession;
import com.dropbox.client2.android.AuthActivity;
import com.dropbox.client2.session.AppKeyPair;
import com.dropbox.client2.session.Session.AccessType;
import com.pfc.src.util.Constants;

/**
 * Clase per fer la sessi amb dropbox
 * @author manu
 *
 */
public class SessionManagerDropBox extends AuthActivity {
	
	
	// Declarem una variable del tipus DropboxAPI
	private DropboxAPI<AndroidAuthSession> mDBApi;


	/**
	 * Mtode que accedeix a la sessi amb els credencials de carpeta
	 * @return
	 */
	public DropboxAPI<AndroidAuthSession> getSession(){
		
		AppKeyPair appKeys = new AppKeyPair(Constants.CLAU_DROPBOX_FOLDER, Constants.SECRETA_DROPBOX_FOLDER);
		AndroidAuthSession session = new AndroidAuthSession(appKeys, AccessType.APP_FOLDER);
		
		mDBApi = new DropboxAPI<AndroidAuthSession>(session);
		
		return mDBApi;
		
	}
	
	/**
	 * Mtode que accedeix a la sessi amb els credencials per tot el DropBox
	 * @return
	 */
	public DropboxAPI<AndroidAuthSession> getSessionFull(){
		
		AppKeyPair appKeys = new AppKeyPair(Constants.CLAU_DROPBOX_GLOBAL, Constants.SECRETA_DROPBOX_GLOBAL);
		AndroidAuthSession session = new AndroidAuthSession(appKeys, AccessType.DROPBOX);
		
		mDBApi = new DropboxAPI<AndroidAuthSession>(session);
		
		return mDBApi;
		
	}

	
	
	


}
